Summary:          C++ I/O communication library
Name:             conexus
Version:          0.9.1
Release:          3%{?dist}.1
License:          GPLv3
URL:              http://conexus.sourceforge.net
Group:            System Environment/Libraries
Source:           http://downloads.sourceforge.net/conexus/%{name}-%{version}.tar.bz2
Patch0:           conexus-0.9.1.f14.patch
BuildRoot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:    glibmm24-devel >= 2.6.0
BuildRequires:    cppunit-devel >= 1.11
BuildRequires:    libcap-devel
BuildRequires:    popt-devel
BuildRequires:    boost-devel
BuildRequires:    pkgconfig
BuildRequires:    m4
BuildRequires:    nspr-devel >= 4.6 nss-devel >= 3.11
%if 0%{?fedora} > 10 || 0%{?rhel} > 5
BuildRequires:    libudev-devel >= 139
%endif
BuildRequires:    gtkmm24-devel >= 2.6
BuildRequires:    papyrus-gtkmm-devel >= 0.10
BuildRequires:    papyrus-extras-devel >= 0.10
BuildRequires:    openssl-devel >= 0.9.8
BuildRequires:    dbus-cxx-glibmm-devel >= 0.6.0
BuildRequires:    dbus-cxx-tools >= 0.6.0

%description
Conexus is a C++ I/O library that includes support for BSD
sockets, serial/tty, packet capture, et. al.

%package          devel
Summary:          C++ Headers for developing programs that will use the conexus I/O library
Group:            Development/Libraries
Requires:         conexus = %{version}-%{release}
Requires:         glibmm24-devel >= 2.6.0
Requires:         pkgconfig
Requires:         libcap-devel
%if 0%{?fedora} > 10 || 0%{?rhel} > 5
Requires:         libudev-devel
%endif

%description    devel
C++ libraries and header files needed for developing applications that
will use the conexus communication library.

%package          doc
Summary:          Developer's documentation for the conexus library
Group:            Documentation
Requires:         gtk-doc
Requires:         devhelp
%if 0%{?fedora} > 9 || 0%{?rhel} > 5
BuildArch:        noarch
%endif

%description      doc
This package contains developer's documentation for the conexus
library. Conexus is a C++ I/O library that includes support for 
BSD sockets, serial/tty, packet capture, et. al.

The documentation can be viewed either through the devhelp
documentation browser or through a web browser. 

If using a web browser the documentation is installed in the gtk-doc
hierarchy and can be found at /usr/share/gtk-doc/html/conexus-0.9

%package          dbus
Summary:          DBus support for the conexus communication library
Group:            System Environment/Libraries
Requires:         conexus = %{version}-%{release}

%description      dbus
This package contains DBus support for the conexus library.

%package          dbus-devel
Summary:          Headers for developing programs that will use conexus-dbus
Group:            Development/Libraries
Requires:         conexus-dbus = %{version}-%{release}
Requires:         conexus-devel = %{version}-%{release}
Requires:         dbus-cxx-devel >= 0.3.4

%description      dbus-devel
This package contains the libraries and header files needed for
developing conexus-dbus applications.

%package          gtkmm
Summary:          Gtkmm UI widgets for the conexus communication library
Group:            System Environment/Libraries
Requires:         conexus = %{version}-%{release}
Provides:         conexusmm = %{version}
Obsoletes:        conexusmm < 0.5.1

%description      gtkmm
This package contains gtkmm widgets associated with the conexus library.

%package          gtkmm-devel
Summary:          Headers for developing programs that will use conexus-gtkmm
Group:            Development/Libraries
Requires:         conexus-gtkmm = %{version}-%{release}
Requires:         conexus-devel = %{version}-%{release}
Requires:         gtkmm24-devel >= 2.6
Requires:         papyrus-gtkmm-devel >= 0.10
Requires:         papyrus-extras-devel >= 0.10
Provides:         conexusmm-devel = %{version}
Obsoletes:        conexusmm-devel < 0.5.1

%description      gtkmm-devel
This package contains the libraries and header files needed for
developing conexus-gtkmm applications.

%package          ssl
Summary:          OpenSSL endpoints for the conexus communication library
Group:            System Environment/Libraries
Requires:         conexus = %{version}-%{release}

%description      ssl
This package contains OpenSSL based endpoints for the conexus library.

%package          ssl-devel
Summary:          Headers for developing programs that will use conexus-ssl
Group:            Development/Libraries
Requires:         conexus-ssl = %{version}-%{release}
Requires:         conexus-devel = %{version}-%{release}
Requires:         openssl-devel >= 0.9.8

%description      ssl-devel
This package contains the libraries and header files needed for
developing conexus-ssl applications.

%package          nspr
Summary:          NSPR endpoints for the conexus communication library
Group:            System Environment/Libraries
Requires:         conexus = %{version}-%{release}

%description      nspr
This package contains NSPR based endpoints for the conexus library.

%package          nspr-devel
Summary:          Headers for developing programs that will use conexus-nspr
Group:            Development/Libraries
Requires:         conexus-nspr = %{version}-%{release}
Requires:         conexus-devel = %{version}-%{release}
Requires:         nspr-devel >= 4.6

%description      nspr-devel
This package contains the libraries and header files needed for
developing conexus-nspr applications.

%package          nss
Summary:          NSS endpoints for the conexus communication library
Group:            System Environment/Libraries
Requires:         conexus = %{version}-%{release}

%description      nss
This package contains NSS based endpoints for the conexus library.

%package          nss-devel
Summary:          Headers for developing programs that will use conexus-nss
Group:            Development/Libraries
Requires:         conexus-nss = %{version}-%{release}
Requires:         conexus-nspr-devel = %{version}-%{release}
Requires:         nss-devel >= 3.11

%description      nss-devel
This package contains the libraries and header files needed for
developing conexus-nspr applications.

%prep
%setup -q
%patch0 -p1

%build

# We need Fedora 11+ for proper udev support
%if 0%{?fedora} > 10 || 0%{?rhel} > 5
%configure --enable-static=no --enable-gtkmm --enable-demos --enable-dbus --enable-udev
%else
%configure --enable-static=no --enable-gtkmm --enable-demos --enable-dbus --disable-udev
%endif

%{__make} %{?_smp_mflags}

%install
%{__rm} -rf %{buildroot}

%{__make} DESTDIR=%{buildroot} INSTALL="%{__install} -p" install
find %{buildroot} -type f -name "*.la" -exec rm -f {} ';'

# Fix documentation installation and put conexus docs under gtk-doc
%{__mkdir} -p %{buildroot}%{_datadir}/gtk-doc/html/conexus-0.9/reference/html/
%{__install} -p --mode=0664 -t %{buildroot}%{_datadir}/gtk-doc/html/conexus-0.9/reference/html/ doc/reference/html/*
%{__install} -p --mode=0664 -t %{buildroot}%{_datadir}/gtk-doc/html/conexus-0.9/ doc/conexus-0.9.devhelp

%clean
%{__rm} -rf %{buildroot}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post dbus -p /sbin/ldconfig

%postun dbus -p /sbin/ldconfig

%post gtkmm -p /sbin/ldconfig

%postun gtkmm -p /sbin/ldconfig

%post ssl -p /sbin/ldconfig

%postun ssl -p /sbin/ldconfig

%post nspr -p /sbin/ldconfig

%postun nspr -p /sbin/ldconfig

%post nss -p /sbin/ldconfig

%postun nss -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%{_libdir}/libconexus.so.*
%doc AUTHORS README COPYING

%files devel
%defattr(-,root,root,-)
%{_libdir}/libconexus.so
%{_libdir}/pkgconfig/conexus-1.0.pc
%dir %{_includedir}/conexus-0.9
%{_includedir}/conexus-0.9/conexus.h
%{_includedir}/conexus-0.9/conexus/
%doc ChangeLog

%files doc
%defattr(-,root,root,-)
%doc %{_datadir}/gtk-doc/html/conexus-0.9/

%files dbus
%defattr(-,root,root,-)
%{_libdir}/libconexus-dbus.so.*

%files dbus-devel
%defattr(-,root,root,-)
%{_libdir}/libconexus-dbus.so
%{_libdir}/pkgconfig/conexus-dbus-1.0.pc
%{_includedir}/conexus-0.9/conexus-dbus.h
%{_includedir}/conexus-0.9/conexus-dbus/

%files gtkmm
%defattr(-,root,root,-)
%{_libdir}/libconexus-gtkmm.so.*

%files gtkmm-devel
%defattr(-,root,root,-)
%{_libdir}/libconexus-gtkmm.so
%{_libdir}/pkgconfig/conexus-gtkmm-1.0.pc
%{_includedir}/conexus-0.9/conexus-gtkmm.h
%{_includedir}/conexus-0.9/conexus-gtkmm/
%{_bindir}/conexus-gtkmm-demo
%{_datadir}/conexus-0.9.1/

%files ssl
%defattr(-,root,root,-)
%{_libdir}/libconexus-ssl.so.*

%files ssl-devel
%defattr(-,root,root,-)
%{_libdir}/libconexus-ssl.so
%{_libdir}/pkgconfig/conexus-ssl-1.0.pc
%{_includedir}/conexus-0.9/conexus-ssl.h
%{_includedir}/conexus-0.9/conexus-ssl/

%files nspr
%defattr(-,root,root,-)
%{_libdir}/libconexus-nspr.so.*

%files nspr-devel
%defattr(-,root,root,-)
%{_libdir}/libconexus-nspr.so
%{_libdir}/pkgconfig/conexus-nspr-1.0.pc
%{_includedir}/conexus-0.9/conexus-nspr.h
%{_includedir}/conexus-0.9/conexus-nspr/

%files nss
%defattr(-,root,root,-)
%{_libdir}/libconexus-nss.so.*

%files nss-devel
%defattr(-,root,root,-)
%{_libdir}/libconexus-nss.so
%{_libdir}/pkgconfig/conexus-nss-1.0.pc
%{_includedir}/conexus-0.9/conexus-nss.h
%{_includedir}/conexus-0.9/conexus-nss/

%changelog
* Fri Oct 08 2010 Jesse Keating <jkeating@redhat.com> - 0.9.1-3.1
- Rebuild for gcc bug 634757

* Fri Sep 17 2010 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.9.1-3
- Patch for changes to g++ C++0x in f14

* Mon Sep 13 2010 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.9.1-2
- Rebuild for NSS lib changes to fix broken dependencies

* Mon Mar  8 2010 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.9.1-1
- New release
- Removed openssl patch since it is now incorporated upstream

* Tue Aug 25 2009 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.9.0-1
- New release
- Make udev buildrequires conditional

* Tue Aug 25 2009 Tomas Mraz <tmraz@redhat.com> - 0.8.0-3
- rebuilt with new openssl

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.8.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Jun  4 2009 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.8.0-1
- New release
- Added -dbus subpackage
    
* Tue May 26 2009 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.7.0-2
- Removed extraneous sysfs-devel from gtkmm subpackage

* Fri May 21 2009 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.7.0-1
- New release
- Added doc subpackage
- Removed HAL dependency
- Removed extraneous docs
- Added libudev0-devel dependency

* Wed Apr  1 2009 Michael Schwendt <mschwendt@fedoraproject.org> - 0.6.0-2
- Fix unowned top-level headers directory (#483305).

* Mon Mar 26 2009 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.6.0-1
- New release
- Changed Sourceforge url to downloads.sf.net from download.sf.net
- Added -p to doc installs
- Updated minimum papyrus-devel version to 0.10
- Updated a few of the descriptions

* Tue Feb 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.98-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Tue Jan 06 2009 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.5.98-1
- New release
- Removed pcap reference from description
- Removed cstring patch - upstream fixed
- Added libcap requires
- Added gtkmm, ssl, nspr and nss subpackages
- Changed papyrus-devel to requires to papyrus-gtkmm-devel
- Added papyrus-extras-devel requires

* Sun Sep 21 2008 Ville Skyttä <ville.skytta at iki.fi> - 0.5.3-5
- Fix Patch0:/%%patch mismatch.

* Mon Mar 03 2008 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.5.3-4
- Added cstring patch
- Added popt-devel requires

* Tue Feb 19 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0.5.3-3
- Autorebuild for GCC 4.3

* Mon Aug 20 2007 Caolan McNamara <caolanm@redhat.com> - 0.5.3-2
- rebuild for boost rebuild

* Tue Mar 13 2007 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.5.3-1
- New release

* Mon Mar 12 2007 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.5.2-1
- New release

* Sun Mar 11 2007 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.5.1-1
- New release

* Sat Mar 10 2007 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.5.0-1
- New release
- Added -p option to make install to preserve timestamps
- Removed cp of docs and changed doc inclusion to docs/reference

* Sun Aug 27 2006 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.4.0-2
- Bumped release for mass rebuild

* Sat Aug 26 2006 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.4.0-1
- New release

* Wed Aug 16 2006 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.3.0-1
- New release
- Removed libpcap dependency; libpcap PacketCapture classes replaced by
  socket based LL::Packet

* Tue Aug  8 2006 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.2.3-2
- Reverted libpcap-devel to libpcap for FE5

* Sun Aug  6 2006 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.2.3-1
- New release fixes serial example bug
- Changed libpcap to libpcap-devel for Fedora development
- Added BuildRequires m4

* Mon Jul 31 2006 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.2.2-1
- Added pkgconfig to -devel Requires
- New release fixes autoconf generated headers

* Sun Jul 30 2006 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.2.1-2
- Added cppunit-devel to BuildRequires
- Changed make to %%{__make}
- Changed %%{name} to autoconf subst that puts specific name in devel requires
- Added comment regarding why cp occurs for docs
- Added package name to globs in so libs, .pc and demos

* Sat Jul 29 2006 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.2.1-1
- New release

* Sat Jul 15 2006 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.2.0-1
- Removed doxygen and graphviz depends
- New release
- Fixed AUTHORS and COPYING doc files

* Wed Mar 29 2006 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.1.17-1
- Added libpcap and pkgconfig -devel Requires and BuildRequires
- Fixed download mirror
- Split gtkmm widgets into conexusgtkmm

* Sun Mar 05 2006 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.1.16-2
- Removed Requires tag, relying on BuildRequires instead
- Cleaned up Source tag and changed to bz2 files
- New upstream release (upstream is me, it's just easier to say it that way)

* Fri Mar 03 2006 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.1.16-1
- Long overdue cleanup of configure.in et. al.
- Docs now install into $prefix/share/doc/{package}-{version}.
- Separate doc rpm consolidated into devel rpm.

* Mon Feb 27 2006 Rick L Vinyard Jr <rvinyard@cs.nmsu.edu> - 0.1.15-1
- Initial version (at least the inital version with a changelog in the .spec)
